#ifndef MAKEDEPEND
#include <stdio.h>
#include <string.h>
#include <time.h>
#endif

#include "cons.h"

extern void FlushAttr(void);
static void draw(time_t t)
{
	struct tm *TM = localtime(&t);
	char Dest[50];
	time_t T;
	
	SetAttr(0x30);
	FlushAttr();
	
	T = 946677600 - t;
	
	if(T >= 0)
		sprintf(Dest, "%ld, %02ld:%02ld:%02ld  ",
			(T/86400), (T/3600)%24, (T/60)%60, T%60);
	else
		Dest[0] = 0;

	strftime(strchr(Dest, 0), 11, "%H:%M:%S", TM);
	printf("\33[s\33[1;%dH%s\33[u", COLS-strlen(Dest), Dest);
}

static time_t oldtime;

void UpdateClock(void)
{
	time_t t = time(NULL);
	
	if(t != oldtime)
		draw(oldtime=t);
}
