#ifndef MAKEDEPEND
#include <stdlib.h>
#endif

#include "messages.h"
#include "cons.h"

void Boksi(int x1,int y1, int x2,int y2, int filled)
{
	int x, y;
	GotoXY(x1,y1);
	SetAttr(filled<0?0x18:0x1F);
	Gprintf("l");
	if(filled>=0)SetAttr(0x1B);
	for(x=x1+1; x<x2; x++)Gputchar('q');
	Gputchar('k');
	if(filled>=0)SetAttr(0x13);
	for(y=y1+1; y<y2; y++)
		if(GotoXY(x1, y), filled>0)
		{
			Gprintf("x");
			SetAttr(filled);
			for(x=x1+1; x<x2; x++)Gputchar(' ');
			SetAttr(0x13);
			Gprintf("x");
		}
		else
		{
			Gputchar('x');
			GotoXY(x2, y);
			Gputchar('x');
		}
	if(filled>=0)SetAttr(0x1B);
	GotoXY(x1, y2);
	Gputchar('m');
	for(x=x1+1; x<x2; x++)Gputchar('q');
	if(filled>=0)SetAttr(0x1F);
	Gprintf("j");
}

void InitMsgWindow(msgwin *w, int x1,int y1, int x2,int y2)
{
	Boksi(w->x1=x1, w->y1=y1, w->x2=x2, w->y2=y2, -1);
	w->lines = y2-y1-1;
	w->Messages = (const char **)calloc(w->lines, sizeof(const char *));
}

void DoneMsgWindow(msgwin *w)
{
	free(w->Messages);
}

void DrawMessageWindow(msgwin *w, int force)
{
	time_t t = time(NULL);
	unsigned a;
	if(!force)
	{
		if(t == w->old)return;
		Message(w, NULL); /* To scroll */
	}
	w->old = t;
	SetAttr(0x03);
	{unsigned wx=WhereX(), wy=WhereY();
	for(a=0; a<w->lines; a++)
	{
		GotoXY(w->x1+1, w->y1+1+a);
		if(a==w->lines-1)SetAttr(0x0B);
		Gprintf("%*s", WhereX-w->x2, w->Messages[a]?w->Messages[a]:"");
	}
	GotoXY(wx, wy);}
}

void Message(msgwin *w, const char *buf)
{
	unsigned a;
	if(!buf || w->Messages[w->lines-1])
		for(a=0; a<w->lines-1; a++)w->Messages[a]=w->Messages[a+1];
	w->Messages[w->lines-1] = buf;
	if(buf)DrawMessageWindow(w, 1);
}
